package pomodoro

import (
	"git.smsvc.net/pomodoro/GoTomato/internal/shared"
	"time"
)

// runs the countdown and updates shared.Message.TimeLeft every second.
func startTimer(remainingSeconds int) bool {
	for remainingSeconds > 0 {
		select {
		case <-pomodoroResetChannel:
			return false
		case <-pomodoroPauseChannel:
			// Nothing to set here, just waiting for the signal
		case <-pomodoroResumeChannel:
			// Nothing to set here, just waiting for the signal
		default:
			// Broadcast the current state to all clients
			if !IsPomodoroPaused() {
				shared.Message.TimeLeft = remainingSeconds
				time.Sleep(time.Second)
				remainingSeconds--
			}
		}
	}

	// Final shared.Message when time reaches zero
	shared.Message.TimeLeft = remainingSeconds

	return true
}
